/*
	Author	: Zarjazz
	Email	: zarjazz@sircd.org
	WebPage	: http://www.sircd.org/

	Copyright (C) 2001,2002  Vincent Sweeney
	----
	Read the LICENSE file for more details
	----
	$Id: plugin.h,v 1.6 2002/01/13 21:33:36 zarjazz Exp $
*/

#define __PLUGIN
#include <ircd_include.h>


#ifndef __PLUGIN_CL_BASE_H
#define __PLUGIN_CL_BASE_H

#ifdef __cplusplus
extern "C" {
#endif

/* Globals */

extern cl_ui_t ui;

/* Prototypes */
cmd_entry_t *init_client_interface (cl_ui_t *ui);

int cmd_admin		(client_t *cl, int pargc, char *pargv[]);
int cmd_away		(client_t *cl, int pargc, char *pargv[]);
int cmd_help		(client_t *cl, int pargc, char *pargv[]);
int cmd_info		(client_t *cl, int pargc, char *pargv[]);
int cmd_invite		(client_t *cl, int pargc, char *pargv[]);
int cmd_ison		(client_t *cl, int pargc, char *pargv[]);
int cmd_join		(client_t *cl, int pargc, char *pargv[]);
int cmd_kick		(client_t *cl, int pargc, char *pargv[]);
int cmd_links		(client_t *cl, int pargc, char *pargv[]);
int cmd_list		(client_t *cl, int pargc, char *pargv[]);
int cmd_lusers		(client_t *cl, int pargc, char *pargv[]);
int cmd_mode		(client_t *cl, int pargc, char *pargv[]);
int cmd_motd		(client_t *cl, int pargc, char *pargv[]);
int cmd_names		(client_t *cl, int pargc, char *pargv[]);
int cmd_nick		(client_t *cl, int pargc, char *pargv[]);
int cmd_notice		(client_t *cl, int pargc, char *pargv[]);
int cmd_part		(client_t *cl, int pargc, char *pargv[]);
int cmd_pass		(client_t *cl, int pargc, char *pargv[]);
int cmd_ping		(client_t *cl, int pargc, char *pargv[]);
int cmd_pong		(client_t *cl, int pargc, char *pargv[]);
int cmd_privmsg		(client_t *cl, int pargc, char *pargv[]);
int cmd_quit		(client_t *cl, int pargc, char *pargv[]);
int cmd_stats		(client_t *cl, int pargc, char *pargv[]);
int cmd_time		(client_t *cl, int pargc, char *pargv[]);
int cmd_topic		(client_t *cl, int pargc, char *pargv[]);
int cmd_user		(client_t *cl, int pargc, char *pargv[]);
int cmd_userhost	(client_t *cl, int pargc, char *pargv[]);
int cmd_userip		(client_t *cl, int pargc, char *pargv[]);
int cmd_version		(client_t *cl, int pargc, char *pargv[]);
int cmd_who			(client_t *cl, int pargc, char *pargv[]);
int cmd_whois		(client_t *cl, int pargc, char *pargv[]);

int send_msg		(client_t *cl, char *name, char *text, bool privmsg);

int query_remote	(client_t *sv, client_t *cl, char *str);


#ifdef __cplusplus
}
#endif

#endif /* __PLUGIN_CL_BASE_H */
