/*
	Author	: Zarjazz
	Email	: zarjazz@sircd.org
	WebPage	: http://www.sircd.org/

	Copyright (C) 2001,2002  Vincent Sweeney
	----
	Read the LICENSE file for more details
	----
	$Id: cmd_ison.c,v 1.3 2002/01/13 21:33:36 zarjazz Exp $
*/

#include <plugin.h>

/****************************************************************
 * All cmd_* functions are called with the client read lock set *
 ****************************************************************/

int cmd_ison (client_t *cl, int pargc, char *pargv[])
{
	client_t *target;
	char buf[BUFSIZE];
	char *name, *str = buf;
	int i = 1;

	if (pargc < 1) goto bail;

	str += sprintf(buf,":%s %.3d %s :", ui.Srv->name, (int) RPL_ISON, cl->name[0] ? cl->name : "*");
	while (name = pargv[i++])
	{
		target = ui.client_find(name);
		if (target)
		{
			int len = strlen(target->name);
			if ((str + len - buf) > (sizeof(buf) - 4)) break;
			memcpy(str, target->name, len);
			str += len;
			*str++ = ' ';
		}
	}
	*str++ = '\r';
	*str++ = '\n';
	*str   = '\0';

	ui.cl_send_raw(cl, buf, str - buf);

	return 0;
bail:
	ui.cl_send_numeric(cl, ERR_NEEDMOREPARAMS, "ISON");
	return 1;
}
