/*
	Author	: Zarjazz
	Email	: zarjazz@sircd.org
	WebPage	: http://www.sircd.org/

	Copyright (C) 2001,2002  Vincent Sweeney
	----
	Read the LICENSE file for more details
	----
	$Id: cmd_kick.c,v 1.3 2002/01/13 21:33:36 zarjazz Exp $
*/

#include <plugin.h>

/****************************************************************
 * All cmd_* functions are called with the client read lock set *
 ****************************************************************/

int cmd_kick (client_t *cl, int pargc, char *pargv[])
{
	bool priv;
	index_t *index;
	channel_t *chan;
	client_t *target;
	char *name, *nick, *msg;

	if (pargc < 2) { ui.cl_send_numeric(cl, ERR_NEEDMOREPARAMS, "KICK"); return 1; }

	name = pargv[1];
	nick = pargv[2];
	msg  = pargv[3];

	/* target */
	target = ui.client_find(nick);
	if (!target) { ui.cl_send_numeric(cl, ERR_NOSUCHNICK, nick); return 1; }

	/* channel */
	chan = ui.channel_find(name);
	if (!chan) { ui.cl_send_numeric(cl, ERR_NOSUCHCHANNEL, name); return 1; }

	/* FIXME: make it an option for opers to kick */
	priv = bit_tst(cl, FL_PRIV);
	if (!priv)
	{
		/* check client is on channel */
		index = ui.client_find_chan(cl,chan);
		if (!index) { ui.cl_send_numeric(cl, ERR_NOTONCHANNEL, chan->name);  return 1; }

		/* check client is an chan-op */
		index = index->cref;
		if (!bit_tst(index,CF_OP)) { ui.cl_send_numeric(cl, ERR_CHANOPRIVSNEEDED, chan->name); return 1; }
	}

	/* check target is on channel */
	index = ui.client_find_chan(target,chan);
	if (!index) { ui.cl_send_numeric(cl, ERR_NOSUCHNICK, target->name); return 1; }

	/* do the client / channel cleanup */
	ui.channel_exit(index,cl,msg,CE_KICK);

	return 0;
}
