/*
	Author	: Zarjazz
	Email	: zarjazz@sircd.org
	WebPage	: http://www.sircd.org/

	Copyright (C) 2001,2002  Vincent Sweeney
	----
	Read the LICENSE file for more details
	----
	$Id: cmd_names.c,v 1.4 2002/01/13 21:33:36 zarjazz Exp $
*/

#include <plugin.h>

/****************************************************************
 * All cmd_* functions are called with the client read lock set *
 ****************************************************************/

int cmd_names (client_t *cl, int pargc, char *pargv[])
{
	bool show;
	channel_t *chan;
	char *name;

	if (pargc < 1) { ui.cl_send_numeric(cl, ERR_NEEDMOREPARAMS, "NAMES"); return 1; }
	name = pargv[1];

	/* check channel exists */
	chan = ui.channel_find(name);
	if (!chan) { ui.cl_send_numeric(cl, ERR_NOSUCHCHANNEL, name); return 1; }

	/* check client can see 'hidden' users */
	show = bit_tst(cl, FL_PRIV) || ui.client_find_chan(cl,chan);

	/* if secret, check client can see channel */
	if (bit_tst(chan, CM_SECRET) && !show) { ui.cl_send_numeric(cl, ERR_NOSUCHCHANNEL, name); return 1; }

	/* send names to client */
	ui.cl_send_names(cl, chan, show);

 	return 0;
}
