/*
	Author	: Zarjazz
	Email	: zarjazz@sircd.org
	WebPage	: http://www.sircd.org/

	Copyright (C) 2001,2002  Vincent Sweeney
	----
	Read the LICENSE file for more details
	----
	$Id: cmd_part.c,v 1.5 2002/01/29 18:39:38 zarjazz Exp $
*/

#include <plugin.h>

/****************************************************************
 * All cmd_* functions are called with the client read lock set *
 ****************************************************************/

int cmd_part (client_t *cl, int pargc, char *pargv[])
{
	channel_t *chan;
	index_t *index;
	char *parted[MAX_ARGS];	/* list of channels parted */
	char *name, *msg;
	int i = 1, j = 0;

	if (pargc < 1) { ui.cl_send_numeric(cl, ERR_NEEDMOREPARAMS, "PART"); return 1; }

	/* did the user send a part message? */
	if (pargc > 1 && pargv[pargc][0] != '#')
	{
		msg = pargv[pargc];
		pargv[pargc] = NULL;
	}
	/* client nick is the default part message */
	else
		msg = cl->name;

	while (name = pargv[i++])
	{
		/* channel */
		chan = ui.channel_find(name);
		if (!chan) { ui.cl_send_numeric(cl, ERR_NOSUCHCHANNEL, name); continue; }

		/* check client is on channel */
		index = ui.client_find_chan(cl,chan);
		if (!index) { ui.cl_send_numeric(cl, ERR_NOTONCHANNEL, chan->name); continue; }

		/* do the client / channel cleanup */
		ui.channel_exit(index,cl,msg,CE_PART);
		parted[j++] = chan->name;
	}

	if (j)
	{
		/* last value sent is part msg */
		parted[j++] = msg;

		/* send NPART message to other servers */
		ui.cl_send_npart(cl, parted, j);
	}

	return 0;
}
