/*
	Author	: Zarjazz
	Email	: zarjazz@sircd.org
	WebPage	: http://www.sircd.org/

	Copyright (C) 2001,2002  Vincent Sweeney
	----
	Read the LICENSE file for more details
	----
	$Id: cmd_user.c,v 1.3 2002/01/13 21:33:36 zarjazz Exp $
*/

#include <plugin.h>

/****************************************************************
 * All cmd_* functions are called with the client read lock set *
 ****************************************************************/

int cmd_user (client_t *cl, int pargc, char *pargv[])
{
	char user	[sizeof(cl->user)];
	char info	[sizeof(cl->info)];

	if (pargc < 4) goto bail;

	if (bit_tst(cl,FL_REGISTERED)) { ui.cl_send_numeric(cl, ERR_ALREADYREGISTRED); return 1; }
/*
 * parv[1] = username           (login name, account)
 * parv[2] = umode mask         (host name)
 * parv[3] = server notice mask (server name)
 * parv[4] = users real name info
*/
	/* username */
	str_extract_valid(user, pargv[1], sizeof(user), ui.valid_nick_char);
	if (user[0] == '\0') goto bail;
	/* info */
	str_copy(info, str_strip(pargv[4]), sizeof(info));
	if (info[0] == '\0') strcpy(info,"No Info");

	/* copy data to client */
	strcpy(cl->user,user);
	strcpy(cl->info,info);

	/* send PING as required */
	ui.client_cookie(cl);

	return 0;
bail:
	ui.cl_send_numeric(cl, ERR_NEEDMOREPARAMS, "USER");
	return 1;
}
