/*
	Author	: Zarjazz
	Email	: zarjazz@sircd.org
	WebPage	: http://www.sircd.org/

	Copyright (C) 2001,2002  Vincent Sweeney
	----
	Read the LICENSE file for more details
	----
	$Id: cmd_userip.c,v 1.3 2002/01/13 21:33:36 zarjazz Exp $
*/

#include <plugin.h>

/****************************************************************
 * All cmd_* functions are called with the client read lock set *
 ****************************************************************/

int cmd_userip (client_t *cl, int pargc, char *pargv[])
{
	client_t *target;
	char userip[USERIPLEN];	/* nick!user@ip of client */
	char *name, *uhost;

	if (pargc > 0)
		name = pargv[1];
	else
		goto bail;

	/* client */
	target = ui.client_find(name);
	if (!target) { ui.cl_send_numeric(cl, ERR_NOSUCHNICK, name); return 1; }

	/* generate the userhost */
	ui.client_userip(target, userip, bit_tst(cl,FL_OPERATOR) ? false : true);
	uhost = strchr(userip,'!') + 1;

	/* send userip details */
	ui.cl_send_numeric(cl, RPL_USERHOST, target->name,
		bit_tst(target, FL_OPERATOR) ? "*" : "",
		target->u.away[0] ? '-' : '+', uhost);

	return 0;
bail:
	ui.cl_send_numeric(cl, ERR_NEEDMOREPARAMS, "USERIP");
	return 1;
}
