/*
	Author	: Zarjazz
	Email	: zarjazz@sircd.org
	WebPage	: http://www.sircd.org/

	Copyright (C) 2001,2002  Vincent Sweeney
	----
	Read the LICENSE file for more details
	----
	$Id: plugin.c,v 1.2 2002/01/13 21:33:36 zarjazz Exp $
*/

#include <plugin.h>

#ifdef WINVER
  #pragma warning(disable : 4090)	// const
#endif

/* ================ */

cl_ui_t ui;

/* Command List */

static cmd_entry_t cmd_entry_list[] = 
{
	/* Connection Commands */
	{ "SERVER",		NULL,			0 },
	{ "OPER",		cmd_oper,		CMD_ISREG },
	{ "SQUIT",		NULL,			CMD_ISREG | CMD_ISOPER },
	/* Misc Commands */
	{ "WALLOPS",	cmd_wallops,	CMD_ISREG | CMD_ISOPER },
	{ "KILL",		cmd_kill,		CMD_ISREG | CMD_ISOPER },
	{ "ERROR",		NULL,			CMD_ISOPER },
	{ "TRACE",		NULL,			CMD_ISREG | CMD_ISOPER },
	{ "CONNECT",	NULL,			CMD_ISREG | CMD_ISOPER },
	/* Other Commands */
	{ "DIE",		cmd_die,		CMD_ISREG | CMD_ISOPER },
	{ "REHASH",		cmd_rehash,		CMD_ISREG | CMD_ISOPER },
	{ "RESTART",	cmd_restart,	CMD_ISREG | CMD_ISOPER },
	/* Terminator */
	{	NULL, NULL, 0 }
};

/*
================
init_client_interface
----------------
plugin initialization
================
*/

cmd_entry_t *init_client_interface (cl_ui_t *srv_ui)
{
	ui = *srv_ui;
	return cmd_entry_list;
}



