/*
	Author	: Zarjazz
	Email	: zarjazz@sircd.org
	WebPage	: http://www.sircd.org/

	Copyright (C) 2001,2002  Vincent Sweeney
	----
	Read the LICENSE file for more details
	----
	$Id: msg_links.c,v 1.3 2002/01/18 20:47:40 zarjazz Exp $
*/

#include <plugin.h>

/****************************************************************
 * All msg_* functions are called with the client read lock set *
 ****************************************************************/

int msg_links (client_t *sv, int pargc, char *pargv[])
{
	client_t *src;
	u_int16_t id;
	int i;

	if (pargc < 1) { ui.sv_send_numeric(sv, ERR_NEEDMOREPARAMS, "LINKS"); return 1; }

	/* which server is this link details about */
	id = atoi(pargv[1]);
	src = ui.server_find_id(id);
	if (!src) { ui.sv_send_fmt(sv, ":%s NOTICE %s :unknown link id: %hu", ui.Srv->name, ui.Srv->name, id); return -1; }

	/* parse links */
	for (i = 2; i <= pargc; i++)
	{
		char ch = pargv[i][0];
		u_int16_t link;
		client_t *dst;
		bool fl_add;

		/* add or delete link */
		if (ch == '+')
			fl_add = true;
		else if (ch == '-')
			fl_add = false;
		else
			return -1;

		/* which link */
		link = atoi(pargv[i] + 1);
		dst = ui.server_find_id(link);
		if (!dst) { ui.sv_send_fmt(sv, ":%s NOTICE %s :unknown link id: %hu", ui.Srv->name, ui.Srv->name, link); return -1; }

		/* (un)set link */
		if (fl_add)
			ui.server_link_add(src,link);
		else
			ui.server_link_del(src,link);
	}

	/* FIXME: update routing table */

	return 0;
}
