/*
	Author	: Zarjazz
	Email	: zarjazz@sircd.org
	WebPage	: http://www.sircd.org/

	Copyright (C) 2001,2002  Vincent Sweeney
	----
	Read the LICENSE file for more details
	----
	$Id: msg_mode.c,v 1.1 2002/02/02 10:32:27 zarjazz Exp $
*/

#include <plugin.h>

/****************************************************************
 * All msg_* functions are called with the client read lock set *
 ****************************************************************/

int msg_mode (client_t *sv, int pargc, char *pargv[])
{
	channel_t *chan;
	client_t *src;
	char *name;

	if (pargc < 2) { ui.sv_send_numeric(sv, ERR_NEEDMOREPARAMS, "MODE"); return 1; }
	name = pargv[1];

	/* get source client from prefix */
	src = get_prefix(pargv[0]);
	if (!src) return 1;

	/* check channel / client exists */
	if (name[0] == '#')
	{
		/* channel */
		chan = ui.channel_find(name);
		if (!chan) return 1;

		/* parse the channel modes */
		ui.channel_parse_mode_str(src,chan,pargv + 2,true);
	}
	/* client flags */
	else
	{
		client_t *target;

		target = ui.client_find(name);
		if (!target) return 1;

		/* parse user modes */
		ui.client_parse_mode_str(src,target,pargv[2],true);
	}

	return 0;
}
