/*
	Author	: Zarjazz
	Email	: zarjazz@sircd.org
	WebPage	: http://www.sircd.org/

	Copyright (C) 2001,2002  Vincent Sweeney
	----
	Read the LICENSE file for more details
	----
	$Id: msg_njoin.c,v 1.2 2002/01/27 22:34:36 zarjazz Exp $
*/

#include <plugin.h>

/****************************************************************
 * All msg_* functions are called with the client read lock set *
 ****************************************************************/

int msg_njoin (client_t *sv, int pargc, char *pargv[])
{
	char userhost[USERHOSTLEN];	/* nick!user@host of client */
	channel_t *chan;
	client_t *cl;
	int i;

	if (pargc < 2) { ui.sv_send_numeric(sv, ERR_NEEDMOREPARAMS, "NJOIN"); return 1; }

	cl = ui.client_find(pargv[1]);
	if (!cl) return 1;

	/* generate the userhost */
	ui.client_userhost(cl,userhost,true);

	for (i = 2; i <= pargc; i++)
	{
		char *name;

		name = pargv[i];
		chan = ui.channel_find(name);
		ui.channel_join(chan, name, cl, userhost);
	}

	return 0;
}
