/*
	Author	: Zarjazz
	Email	: zarjazz@sircd.org
	WebPage	: http://www.sircd.org/

	Copyright (C) 2001,2002  Vincent Sweeney
	----
	Read the LICENSE file for more details
	----
	$Id: msg_npart.c,v 1.2 2002/01/29 18:39:38 zarjazz Exp $
*/

#include <plugin.h>

/****************************************************************
 * All msg_* functions are called with the client read lock set *
 ****************************************************************/

int msg_npart (client_t *sv, int pargc, char *pargv[])
{
	client_t *cl;
	char *msg;
	int i;

	if (pargc < 2) { ui.sv_send_numeric(sv, ERR_NEEDMOREPARAMS, "NPART"); return 1; }

	cl = ui.client_find(pargv[1]);
	if (!cl) return 1;

	/* extract part msg */
	msg = pargv[pargc--];

	for (i = 2; i <= pargc; i++)
	{
		channel_t *chan;
		index_t *index;
		char *name;

		name = pargv[i];

		/* channel */
		chan = ui.channel_find(name);
		if (!chan) continue;

		/* check client is on channel */
		index = ui.client_find_chan(cl,chan);
		if (!index) continue;

		/* do the client / channel cleanup */
		ui.channel_exit(index,cl,msg,CE_PART);
	}

	return 0;
}
