/*
	Author	: Zarjazz
	Email	: zarjazz@sircd.org
	WebPage	: http://www.sircd.org/

	Copyright (C) 2001,2002  Vincent Sweeney
	----
	Read the LICENSE file for more details
	----
	$Id: msg_njoin.c,v 1.2 2002/01/27 22:34:36 zarjazz Exp $
*/

#include <plugin.h>

/****************************************************************
 * All msg_* functions are called with the client read lock set *
 ****************************************************************/

int msg_topic (client_t *sv, int pargc, char *pargv[])
{
	channel_t *chan;
	client_t *src;

	if (pargc < 1) { ui.sv_send_numeric(sv, ERR_NEEDMOREPARAMS, "TOPIC"); return 1; }

	/* get source client from prefix */
	src = get_prefix(pargv[0]);
	if (!src) return 1;

	/* find channel */
	chan = ui.channel_find(pargv[1]);
	if (!chan) return 1;

	/* copy the topic */
	str_copy(chan->topic, pargv[2], sizeof(chan->topic));
	str_copy(chan->topic_user, src->name, sizeof(chan->topic_user));
	chan->tv_topic = ui.Now->tv_sec;

	/* send topic to client */
	ui.chan_send_fmt(chan, NULL, FL_LOCAL, 0,
		":%s TOPIC %s :%s", pargv[0], chan->name, chan->topic);

	return 0;
}
