/*
	Author	: Zarjazz
	Email	: zarjazz@sircd.org
	WebPage	: http://www.sircd.org/

	Copyright (C) 2001,2002  Vincent Sweeney
	----
	Read the LICENSE file for more details
	----
	$Id: msg_user.c,v 1.4 2002/01/27 22:34:36 zarjazz Exp $
*/

#include <plugin.h>

/****************************************************************
 * All msg_* functions are called with the client read lock set *
 ****************************************************************/

int msg_user (client_t *sv, int pargc, char *pargv[])
{
	char *nick, *user, *host;
	client_t *cl;
	
	/* sanity check */
	if (pargc < 4) { ui.sv_send_numeric(sv, ERR_NEEDMOREPARAMS, "USER"); return 1; }
	
	/* extract clients nick,user & host */
	nick = pargv[1];
	user = strchr(nick,'!'); *user++ = '\0';
	host   = strchr(user,'@'); *host++ = '\0';

	/* check the client details */
	cl = ui.client_find(nick);
	if (cl)
	{
		if (strcmp(user, cl->user) || strcmp(host, cl->host))
		{
			/* collision */
			
		}
		else
		{
			/* existing client */
			/* FIXME: check server node id */
			
		}
	}
	else
	{
		/* new client */
		client_t *src = get_prefix(pargv[2]);
		char *umode = pargv[3], *info = pargv[4];

		if (!src) { sys_dprintf(3,"USER from unknown server (%s)\n",pargv[2]); return 1; }

		/* create the new client structure */
		cl = ui.client_create_remote(src, nick, user, host);
		//bit_set(cl,FL_BUSY); /* denote this client is linking */
	}

	return 0;
}
