/*
	Author	: Zarjazz
	Email	: zarjazz@sircd.org
	WebPage	: http://www.sircd.org/

	Copyright (C) 2001,2002  Vincent Sweeney
	----
	Read the LICENSE file for more details
	----
	$Id: plugin.c,v 1.8 2002/01/19 01:04:24 zarjazz Exp $
*/

#include <plugin.h>

/* ================ */

sv_ui_t ui;

/* Command List */
static cmd_entry_t msg_entry_list[] = 
{
	/* Commands */
	{ "USER",		msg_user,		0 },
	{ "MSG",		msg_msg,		CMD_RDCHAN },
	{ "MODE",		msg_mode,		CMD_RDCHAN },
	{ "SYNC",		msg_sync,		CMD_WRCHAN },
	{ "LINKS",		msg_links,		0 },
	{ "TOPIC",		msg_topic,		CMD_RDCHAN },
	/* Connection Commands */
	{ "NJOIN",		msg_njoin,		CMD_WRCHAN },
	{ "NPART",		msg_npart,		CMD_WRCHAN },
	/* Connection Commands */
	{ "PASS",		msg_pass,		0 },
	{ "SERVER",		msg_server,		0 },
	/* Misc Commands */
	{ "NOTICE",		msg_notice,		0 },
	{ "PING",		msg_ping,		0 },
	{ "PONG",		msg_pong,		0 },
	/* Terminator */
	{	NULL, NULL, 0 }
};

/*
================
get_prefix
================
*/

client_t *get_prefix (char *prefix)
{
	if (prefix)
	{
		if (isdigit(*prefix))
		{
			/* this is a server numeric */
			u_int16_t id;
			client_t *src;

			if (id = atoi(prefix))
				if (src = ui.server_find_id(id)) return src;
		}
		else
		{
			/* this is a client userhost */
			char *s = strchr(prefix,'!');
			if (s)
			{
				client_t *cl;

				*s = '\0';
				cl = ui.client_find(prefix);
				*s = '!';
				return cl;
			}
		}
	}

	return NULL;
}

/*
================
init_client_interface
----------------
plugin initialization
================
*/

cmd_entry_t *init_server_interface (sv_ui_t *srv_ui)
{
	ui = *srv_ui;
	return msg_entry_list;
}



