/*
	Author	: Zarjazz
	Email	: zarjazz@sircd.org
	WebPage	: http://www.sircd.org/

	Copyright (C) 2001,2002  Vincent Sweeney
	----
	Read the LICENSE file for more details
	----
	$Id: core_cache.h,v 1.2 2002/01/13 21:33:36 zarjazz Exp $
*/

#ifndef __CORE_CACHE_H
#define __CORE_CACHE_H

#ifdef __cplusplus
extern "C" {
#endif

/* Typedefs */

typedef struct ip_tree_s
{
	/* tree links */
	struct ip_tree_s *left;
	struct ip_tree_s *right;
	/* tree data */
	u_int32_t tv_sec;
	u_int32_t count;
} ip_tree_t;

/* Prototypes */

void init_ip_cache		(void);

ip_tree_t *	ip_add		(u_int32_t ip, u_int32_t tv_sec, bool lock);
void		ip_del		(u_int32_t ip);
u_int32_t	ip_branches	(void);
ip_tree_t *	ip_find		(u_int32_t ip);
u_int32_t	ip_count	(u_int32_t ip, int subnet);


#ifdef __cplusplus
}
#endif

#endif /* __CORE_CACHE_H */	 
