/*
	Author	: Zarjazz
	Email	: zarjazz@sircd.org
	WebPage	: http://www.sircd.org/

	Copyright (C) 2001,2002  Vincent Sweeney
	----
	Read the LICENSE file for more details
	----
	$Id: core_node.h,v 1.3 2002/01/15 23:04:42 zarjazz Exp $
*/

#ifndef __CORE_NODE_H
#define __CORE_NODE_H

#ifdef __cplusplus
extern "C" {
#endif


/* Typedefs */
typedef struct
{
	/* Node Details */
	u_int16_t	id;
	u_int16_t	protocol;
	/* Link Details */
	u_int16_t	*route, *neighbours;
	u_int16_t	num_neighbours;
} node_t;

/* Prototypes */
void	init_nodes	(node_t *node, unsigned max_nodes);

void	link_add	(node_t *node, u_int16_t id);
void	link_del	(node_t *node, u_int16_t id);

void	link_state_string	(char *dst, node_t *node);
node_t *node_find_route		(u_int16_t id);

/* Globals */
extern node_t  *Node;


#ifndef __PLUGIN

#endif /* __PLUGIN */

#ifdef __cplusplus
}
#endif

#endif /* __CORE_NODE_H */	 
