/*
	Author	: Zarjazz
	Email	: zarjazz@sircd.org
	WebPage	: http://www.sircd.org/

	Copyright (C) 2001,2002  Vincent Sweeney
	----
	Read the LICENSE file for more details
	----
	$Id: core_sendq.h,v 1.2 2002/01/13 21:33:36 zarjazz Exp $
*/

#ifndef __CORE_SENDQ_H
#define __CORE_SENDQ_H

#ifdef __cplusplus
extern "C" {
#endif

/* Typedefs */

typedef struct sendq_pkt_s
{
	struct sendq_pkt_s	*next;
	/* data */
	sys_pkt_t pkt;
} sendq_pkt_t;

typedef struct sendq_s
{
	int			npackets;
	size_t		nbytes;
	sendq_pkt_t	*start, *end;
	mutex_t		mutex;
} sendq_t;

/* Prototypes */

void			sendq_init		(sendq_t *sendq);
void			sendq_insert	(sendq_t *sendq, sendq_pkt_t *entry);
sendq_pkt_t *	sendq_remove	(sendq_t *sendq);


#ifdef __cplusplus
}
#endif

#endif /* __CORE_SENDQ_H */	 
