/*
	Author	: Zarjazz
	Email	: zarjazz@sircd.org
	WebPage	: http://www.sircd.org/

	Copyright (C) 2001,2002  Vincent Sweeney
	----
	Read the LICENSE file for more details
	----
	$Id: core_tree.h,v 1.3 2002/01/13 21:33:36 zarjazz Exp $
*/

#ifndef __CORE_TREE_H
#define __CORE_TREE_H

#ifdef __cplusplus
extern "C" {
#endif

/* Typedefs */

typedef struct tree_s
{
	/* tree links */
	struct tree_s *left;
	struct tree_s *right;
	struct tree_s *parent;
	/* linked list links */
	struct tree_s *prev;
	struct tree_s *next;
	/* tree data */
	char *key;
} tree_t;

typedef struct tree_list_s
{
	int		nitems;
	tree_t	*item_start;
	tree_t	*item_end;
} tree_list_t;

/* Prototypes */

#ifndef __PLUGIN
	void		tree_del	(tree_t **root, tree_t *node);
	tree_t *	tree_add	(tree_t **root, tree_t *node);
	tree_t *	tree_find	(tree_t  *root, char *key);

	void		list_add_start	(tree_list_t *llist, tree_t *item);
	void		list_add_end	(tree_list_t *llist, tree_t *item);
	void		list_del_item	(tree_list_t *llist, tree_t *item);

#endif /* __PLUGIN */


#ifdef __cplusplus
}
#endif

#endif /* __CORE_TREE_H */	 
