/*
	Author	: Zarjazz
	Email	: zarjazz@sircd.org
	WebPage	: http://www.sircd.org/

	Copyright (C) 2001,2002  Vincent Sweeney
	----
	Read the LICENSE file for more details
	----
	$Id: ircd_commands.h,v 1.4 2002/01/18 20:47:40 zarjazz Exp $
*/

#ifndef __SRV_COMMANDS_H
#define __SRV_COMMANDS_H

#ifdef __cplusplus
extern "C" {
#endif


/* Defines */

#define CMD_RDCHAN	(1 << 0)	/* Command requires channel read lock */
#define CMD_WRCHAN	(1 << 1)	/* Command requires channel write lock */
#define CMD_ISREG	(1 << 2)	/* Command requires registration */
#define CMD_ISOPER	(1 << 3)	/* Command requires operator privaledges */
#define CMD_IDLE	(1 << 4)	/* Command does not reset idle time */

/* max args = max parameters + 2 */
#define MAX_ARGS (16 + 2)

/* Typedefs */
typedef int	(*CMD_API) (/*client_t *sv,*/ client_t *cl, int pargc, char *pargv[]);

typedef struct
{
	char *cmd;
	CMD_API func;
	int	flags;
} cmd_entry_t;

/* Prototypes */
#ifndef __PLUGIN
	void	init_plugins	(void);
	void	load_plugins	(bool lock, bool reload);

	char *	parse_command	(int *pargc, char *pargv[], byte *data);
	void	cmd_parse		(client_t *cl, byte *data, size_t size);

	extern cmd_entry_t *CMD_ENTRY_LIST;
	extern cmd_entry_t *MSG_ENTRY_LIST;
#endif /* __PLUGIN */


#ifdef __cplusplus
}
#endif

#endif /* __SRV_COMMANDS_H */	 
