/*
	Author	: Zarjazz
	Email	: zarjazz@sircd.org
	WebPage	: http://www.sircd.org/

	Copyright (C) 2001,2002  Vincent Sweeney
	----
	Read the LICENSE file for more details
	----
	$Id: ircd_include.h,v 1.5 2002/01/13 21:33:36 zarjazz Exp $
*/

/* Defines */

#ifdef IPV6
#	define IPLEN	16
#else
#	define IPLEN	46
#endif /* IPV6 */

#define IPPORTLEN	(IPLEN + 6)

#undef HOSTLEN

#ifdef WINVER
  #define snprintf _snprintf
#endif /* WINVER */

/* Options */
#include <options.h>

#define USERHOSTLEN	(NICKLEN + USERLEN + HOSTLEN)
#define USERIPLEN	(NICKLEN + USERLEN + IPLEN)

/* Headers */
#include <sys_include.h>
#include <sys_common.h>
#include <sys_string.h>
#include <sys_array.h>
#include <sys_list.h>
#include <sys_config.h>
#include <sys_network.h>

#ifdef HAVE_SSL
	#include <openssl/ssl.h>
	#include <openssl/err.h>
#endif /* HAVE_SSL */

#include <core_tree.h>
#include <core_cache.h>
#include <core_threads.h>
#include <core_sendq.h>
#include <core_node.h>

#include <ircd_threads.h>
#include <ircd_config.h>
#include <ircd_client.h>
#include <ircd_servers.h>
#include <ircd_channel.h>
#include <ircd_commands.h>
#include <ircd_callbacks.h>
#include <ircd_misc.h>

#include <net_numerics.h>
#include <net_network.h>
#include <net_ssl.h>

#include <ircd_plugins.h>

#ifndef __IRCD_INCLUDE_H
#define __IRCD_INCLUDE_H

#ifdef __cplusplus
extern "C" {
#endif


/* RFC says IRC packets are at most 512 bytes */
#define BUFSIZE 512

/* Globals */
#ifndef __PLUGIN 
	extern volatile bool terminate;
	extern rwlock_t rwlock_ip;
	extern rwlock_t rwlock_clients;
	extern rwlock_t rwlock_channels;
	extern rwlock_t rwlock_commands;

#ifdef HAVE_SSL
	extern SSL_CTX *Ctx;
#endif /* HAVE_SSL */

	extern struct timeval Now;
	extern options_t *Options;
	extern block_t *Config;
	extern char *VERSION, *CDATE, *CTIME, *CFILE;
#endif /* __PLUGIN */


#ifdef __cplusplus
}
#endif

#endif /* __IRCD_INCLUDE_H */	 
