/*
	Author	: Zarjazz
	Email	: zarjazz@sircd.org
	WebPage	: http://www.sircd.org/

	Copyright (C) 2001,2002  Vincent Sweeney
	----
	Read the LICENSE file for more details
	----
	$Id: ircd_misc.h,v 1.2 2002/01/13 21:33:36 zarjazz Exp $
*/

#ifndef __SRV_MISC_H
#define __SRV_MISC_H

#ifdef __cplusplus
extern "C" {
#endif


/* Typedefs */

struct userstats_s
{
	int32_t N_users;
	int32_t N_invis;
	int32_t N_opers;
	int32_t N_chans;
	int32_t N_servs;
	int32_t N_max_users;
};

/* Prototypes */

#ifndef __PLUGIN
	void	ircd_terminate	(void);
	void	ircd_rehash		(client_t *cl);

	void	invite_remove	(client_t *cl, index_t *index);
	void	ban_remove		(channel_t *chan, ban_t *ban, char *userhost);
	void	ban_add			(channel_t *chan, client_t *cl, char *ban_str, char *userhost);

	int		valid_nick_char	(int ch);
	int		valid_chan_char	(int ch);

	char *	sanify_ban		(char *dst, char *src);
	char *	host_encrypt	(const char *host);
	char *	sha_string		(char *dst, const char *src);

	void	debug_memory	(client_t *cl);
	void	show_motd		(client_t *cl);

	u_int32_t chan_mode (char ch);
	u_int32_t user_mode (char ch);
#endif /* __PLUGIN */

/* Globals */
#ifndef __PLUGIN

extern struct userstats_s UserStats;

#endif /* __PLUGIN */


#ifdef __cplusplus
}
#endif

#endif /* __SRV_MISC_H */	 
