/*
	Author	: Zarjazz
	Email	: zarjazz@sircd.org
	WebPage	: http://www.sircd.org/

	Copyright (C) 2001,2002  Vincent Sweeney
	----
	Read the LICENSE file for more details
	----
	$Id: ircd_threads.h,v 1.3 2002/01/13 21:33:36 zarjazz Exp $
*/

#ifndef __SRV_THREADS_H
#define __SRV_THREADS_H

#ifdef __cplusplus
extern "C" {
#endif

/* Typedefs */

typedef struct worker_s
{
	/* linked list elements */
	struct worker_s *next;
	struct worker_s *prev;
	/* structure data */

	/* thread stuff */
	thread_t	thread;
	bool		die;
} worker_t;

typedef struct task_s
{
	/* linked list elements */
	struct task_s *next;
	struct task_s *prev;
	/* structure data */
	void (* callback) (void *, void *);
	void *arg1;
	void *arg2;
} task_t;

typedef struct listener_s
{
	/* linked list elements */
	struct listener_s *next;
	struct listener_s *prev;
	/* structure data */
	struct sockaddr_in sa;	/* virtual address or INADDR_ANY */
	u_int16_t	sock;		/* socket descriptor */
#ifdef HAVE_SSL
	bool	use_ssl;
#endif /* HAVE_SSL */
	u_int32_t	flags;
	u_int32_t	user_count;	/* connection count */
	u_int32_t	user_max;	/* max connection count */
	time_t	last_accept;	/* last time listener accepted */
	/* client list */
	tree_list_t list;
	/* thread stuff */
	thread_t	thread;
	bool		die;
} listener_t;

/* Prototypes */
#ifndef __PLUGIN
	void	init_threads	(void);

	void	create_workers	(int);
	void	create_listeners(block_t *config);
	void	create_servers	(block_t *config);

	void	task_submit		(task_t *task);
	void	task_create		(void (* callback) (void *, void *), void *arg1, void *arg2);
#endif /* __PLUGIN */


#ifdef __cplusplus
}
#endif

#endif /* __SRV_THREADS_H */	 
