/*
	Author	: Zarjazz
	Email	: zarjazz@sircd.org
	WebPage	: http://www.sircd.org/

	Copyright (C) 2001,2002  Vincent Sweeney
	----
	Read the LICENSE file for more details
	----
	$Id: net_network.h,v 1.6 2002/01/27 22:34:36 zarjazz Exp $
*/

#ifndef __NET_NEWORK_H
#define __NET_NEWORK_H

#ifdef __cplusplus
extern "C" {
#endif

/* Defines */

#define SELECT(x) if ((x)) { FD_SET((x),fdp); if ((x) > maxSock) maxSock = (x); }
#define LISTEN(x) ((x) && FD_ISSET((x),fdp))

/* Prototypes */
#ifndef __PLUGIN
	void net_loop_parent	(void);
	void net_loop_server	(client_t *server);
	void net_loop_listener	(listener_t *listener);

	int read_timeout		(u_int16_t sock, unsigned secs, unsigned usecs);
	int send_timeout		(u_int16_t sock, unsigned secs, unsigned usecs);

	void cl_send_raw		(client_t *cl, byte *buffer, int len);

	void cl_send_fmt		(client_t *cl, const char *fmt, ...);
	void cl_send_numeric	(client_t *cl, numeric_t numeric, ...);

	void cl_send_names		(client_t *cl, channel_t *chan, bool show);
	void cl_send_njoin		(client_t *cl, char *joined[], int j);
	void cl_send_npart		(client_t *cl, char *parted[], int j);

	void chan_send_fmt		(channel_t *chan, client_t *exclude, u_int32_t filter_cl, u_int32_t filter_index,
								const char *fmt, ...);
	void chan_send_numeric	(channel_t *chan, client_t *cl, client_t *exclude, numeric_t numeric, ...);

	void all_send_fmt		(u_int32_t filter, const char *fmt, ...);
#endif /* __PLUGIN */


#ifdef __cplusplus
}
#endif

#endif /* __NET_NEWORK_H */	 
