/*
	Author	: Zarjazz
	Email	: zarjazz@sircd.org
	WebPage	: http://www.sircd.org/
	----
	$Id: sys_list.h,v 1.2 2001/05/03 22:20:47 zarjazz Exp $
*/

#ifndef __SYS_LIST_H
#define __SYS_LIST_H

#ifdef __cplusplus
extern "C" {
#endif

/* Typedefs */

typedef struct ll_item_s
{
	struct ll_item_s	*next;
	struct ll_item_s	*prev;
} ll_item_t;


typedef struct llist_s
{
	int			nitems;
	ll_item_t	*item_start;
	ll_item_t	*item_end;
} llist_t;

/* Prototypes */

DLL_API	void _ll_add_start	(llist_t *llist, ll_item_t *item);
DLL_API	void _ll_add_end	(llist_t *llist, ll_item_t *item);
DLL_API	void _ll_del_item	(llist_t *llist, ll_item_t *item);

#define ll_add_start(llist, item) _ll_add_start(llist, (ll_item_t *) item)
#define ll_add_end(llist, item) _ll_add_end(llist, (ll_item_t *) item)
#define ll_del_item(llist, item) _ll_del_item(llist, (ll_item_t *) item)


#ifdef __cplusplus
}
#endif

#endif /* __SYS_LIST_H */	 
